// MyFirstATLServerWebService.h : Defines the ATL Server request handler class
//
#pragma once

namespace MyFirstATLServerWebServiceService
{
// all struct, enum, and typedefs for your webservice should go inside the namespace

// IMyFirstATLServerWebServiceService - web service interface declaration
//
[
	uuid("D1A6DAD0-02A1-4FF7-BB79-65C8D8150A91"), 
	object
]
__interface IMyFirstATLServerWebServiceService
{
	// HelloWorld is a sample ATL Server web service method.  It shows how to
	// declare a web service method and its in-parameters and out-parameters
	[id(1)] HRESULT HelloWorld([in] BSTR bstrInput, [out, retval] BSTR *bstrOutput);
	// TODO: Add additional web service methods here
};


// MyFirstATLServerWebServiceService - web service implementation
//
[
	request_handler(name="Default", sdl="GenMyFirstATLServerWebServiceWSDL"),
	soap_handler(
		name="MyFirstATLServerWebServiceService", 
		namespace="urn:MyFirstATLServerWebServiceService",
		protocol="soap"
	)
]
class CMyFirstATLServerWebServiceService :
	public IMyFirstATLServerWebServiceService
{
public:
	// This is a sample web service method that shows how to use the 
	// soap_method attribute to expose a method as a web method
	[ soap_method ]
	HRESULT HelloWorld(/*[in]*/ BSTR bstrInput, /*[out, retval]*/ BSTR *bstrOutput)
	{
		CComBSTR bstrOut(L"Hello ");
		bstrOut += bstrInput;
		bstrOut += L"!";
		*bstrOutput = bstrOut.Detach();
		
		return S_OK;
	}
	// TODO: Add additional web service methods here
}; // class CMyFirstATLServerWebServiceService

} // namespace MyFirstATLServerWebServiceService
